package com.th.demo.service.impl.ware;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.TypeReference;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.th.demo.mapping.maint.CustomerMapper;
import com.th.demo.mapping.ware.ChangeRecordMapper;
import com.th.demo.mapping.ware.InRecordMapper;
import com.th.demo.mapping.ware.StoreMapper;
import com.th.demo.model.maint.Customer;
import com.th.demo.model.maint.Stack;
import com.th.demo.model.system.Type;
import com.th.demo.model.ware.ChangeRecord;
import com.th.demo.model.ware.InRecord;
import com.th.demo.model.ware.SplitRecord;
import com.th.demo.model.ware.Store;
import com.th.demo.service.maint.CustomerService;
import com.th.demo.service.ware.StoreService;
import com.th.demo.tools.JSONTools;
import com.th.demo.tools.Tools;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.List;

@Service("StoreService")
public class StoreServiceImpl implements StoreService {

    @Autowired//自动注入Mapper
    public ChangeRecordMapper changeRecordMapper;
    @Autowired//自动注入Mapper
    public StoreMapper storeMapper;
    @Autowired//自动注入Mapper
    public CustomerMapper customerMapper;
    @Autowired//自动注入Mapper
    public InRecordMapper inRecordMapper;
    String result = Type.FAIL;
    int num = 0;

    @Override
    public String queryLayerByStackId(String stackId, String userId, String belongId) {

        String layer = storeMapper.selectLayerByStackId(stackId, belongId);
        if (layer == null) {
            layer = "0";
        }
        int currentLayer = Integer.parseInt(layer) + 1;
        result = JSONTools.toStringyyyyMMddHHmmss(currentLayer);
        return result;
    }

    @Override
    public String queryByWareIdStackId(String wareId, String stackId, String userId, String belongId) {
       List<Store> list =  storeMapper.selectByWareIdStackId(  wareId,   stackId, belongId);
        result = JSONTools.toStringyyyyMMddHHmmss(list);
        return result;
    }

    @Override
    public String query(int page, int rows, String wareName, String stackName, String userId, String belongId) {
        PageHelper.startPage(page, rows);
        List<Store> list   = storeMapper.select(wareName, stackName, userId,belongId);
        PageInfo<Store> pageInfo = new PageInfo<>(list);
        result = JSONTools.toStringyyyyMMddHHmmss(pageInfo);
        return result;
    }

    @Override
    public String modify(String json, String userId, String belongId) {
        Store store = JSON.parseObject(json,Store.class);
        int num =storeMapper.updateByPrimaryKey(store);
        result=Tools.moreThanZeroResultJSON(num);
        return result;
    }

    @Override
    public String queryStore(int page, int rows,
                             String wareName,
                             String stackName,
                             String model,
                             String materialName,
                             String standard,
                             String customerName,
                             String userId,
                             String belongId,
                             String plateNo,
                             String ordNo,
                             String contractNo,
                             String fkcustmerName) {
        List<String> pltNos =new ArrayList<>() ;
        List<String> ordNos =new ArrayList<>() ;
        List<String> contractNos =new ArrayList<>() ;
        if (plateNo.indexOf(",") != -1){
            pltNos = Arrays.asList(plateNo.split(","));
        }
        if (ordNo.indexOf(",") != -1){
            ordNos = Arrays.asList(ordNo.split(","));
        }
        if (contractNo.indexOf(",") != -1){
            contractNos = Arrays.asList(contractNo.split(","));
        }

        if (page == -1 && rows == -1){
            List<Store> list=storeMapper.selectStore(wareName,stackName,model,materialName,standard,    customerName,   userId,belongId,
                    fkcustmerName,plateNo,ordNo,contractNo,pltNos,ordNos,contractNos);
            result = JSONTools.toStringyyyyMMddHHmmss(list);
        }else {
            PageHelper.startPage(page, rows);
            List<Store> list=storeMapper.selectStore(wareName,stackName,model,materialName,standard,    customerName,   userId,belongId,
                    fkcustmerName,plateNo,ordNo,contractNo,pltNos,ordNos,contractNos);
            PageInfo<Store> pageInfo = new PageInfo<>(list);
            result = JSONTools.toStringyyyyMMddHHmmss(pageInfo);
        }

        return result;
    }

    @Override
    public String modifyCustomer(String id,String customerNameOld,String customerNameNew) {
//        Store store =storeMapper.selectByPrimaryKey(id);
//        store.setCustomerName(customerNameNew);
//        ChangeRecord changeRecord =new ChangeRecord();
//        changeRecord.setWareName(store.getWareName());
//        changeRecord.setStackName(store.getStackName());
//        changeRecord.setId(store.getId());
//        changeRecord.setLayer(store.getLayer());
//        changeRecord.setMaterialName(store.getMaterialName());
//        changeRecord.setMaterialNo(store.getMaterialNo());
//        changeRecord.setStandard(store.getStandard());
//        changeRecord.setModel(store.getModel());
//        changeRecord.setCustomerNameOld(customerNameOld);
//        changeRecord.setCustomerNameNew(customerNameNew);
//        changeRecord.setCount(store.getCount());
//        changeRecord.setRemark(store.getRemark());
//        changeRecord.setAddTime(store.getAddTime());
//        changeRecord.setModifyId(store.getModifyId());
//        changeRecord.setModifyTime(store.getModifyTime());
//        changeRecord.setCancelId(store.getCancelId());
//        changeRecord.setCancelTime(store.getCancelTime());
//        changeRecord.setCancelFlag(store.getCancelFlag());
//        changeRecord.setBelongId(store.getBelongId());
//        changeRecord.setPlateNo(store.getPlateNo());
//        changeRecord.setOutId(store.getOutId());
//        changeRecord.setAddId(store.getAddId());
//
//        changeRecordMapper.insert(changeRecord);
//        num = storeMapper.updateByPrimaryKey(store);
//        result = JSONTools.toString(num);
        return result;
    }

    @Override
    public String modifyCustomeradress(String id, String customerAddressOld, String customerAddressNew) {
//        Store store =storeMapper.selectByPrimaryKey(id);
//        store.setReceiveAddress(customerAddressNew);
//        ChangeRecord changeRecord =new ChangeRecord();
//        changeRecord.setWareName(store.getWareName());
//        changeRecord.setStackName(store.getStackName());
//        changeRecord.setId(store.getId());
//        changeRecord.setLayer(store.getLayer());
//        changeRecord.setMaterialName(store.getMaterialName());
//        changeRecord.setMaterialNo(store.getMaterialNo());
//        changeRecord.setStandard(store.getStandard());
//        changeRecord.setModel(store.getModel());
//        changeRecord.setReceiveAddressNew(store.getReceiveAddress());
//        changeRecord.setCustomerNameNew(customerAddressNew);
//        changeRecord.setCustomerNameOld(customerAddressOld);
//        changeRecord.setCount(store.getCount());
//        changeRecord.setRemark(store.getRemark());
//        changeRecord.setAddTime(store.getAddTime());
//        changeRecord.setModifyId(store.getModifyId());
//        changeRecord.setModifyTime(store.getModifyTime());
//        changeRecord.setCancelId(store.getCancelId());
//        changeRecord.setCancelTime(store.getCancelTime());
//        changeRecord.setCancelFlag(store.getCancelFlag());
//        changeRecord.setBelongId(store.getBelongId());
//        changeRecord.setPlateNo(store.getPlateNo());
//        changeRecord.setOutId(store.getOutId());
//        changeRecord.setAddId(store.getAddId());
//
//        changeRecordMapper.insert(changeRecord);
//        num = storeMapper.updateByPrimaryKey(store);
//        result = JSONTools.toString(num);
        return result;
    }

    //



//    @Override
//    public String save(String json, String userId) {
//        Assets  assets = JSON.parseObject(json, Assets.class);
//        Assets isnull = assetsMapper.selectByPrimaryKey(assets.getId());
//        assets.setStatus("正常");
//        if(isnull==null){
//        /*assets.setAddId(userId);
//        assets.setAddTime(new Date());
//        assets.setCancelFlag("0");*/
//            num = assetsMapper.insert(assets);
//            result =JSONTools.toString(num);
//        }else{
//        /*arcd.setModifyId(userId);
//        arcd.setModifyTime(new Date());*/
//            num = assetsMapper.updateByPrimaryKey(assets);
//            result =JSONTools.toString(num);
//        }
//        return result;
//    }

//
//    @Override
//    public String save(String json, String userId, String belongId) {
//        result = Type.FAIL;
//        Customer customer = JSON.parseObject(json, new TypeReference<Customer>() {
//        });
//        if (customer.getId() == null || customer.getId().equals("")) {
//            customer.setAddId(userId);
//            customer.setAddTime(new Date());
//            customer.setModifyId(userId);
//            customer.setModifyTime(new Date());
//            customer.setCancelFlag("0");
//            customer.setBelongId(belongId);
//            num = customerMapper.insert(customer);
//        } else {
//            customer.setModifyId(userId);
//            customer.setModifyTime(new Date());
//            num = customerMapper.updateByPrimaryKey(customer);
//        }
//        result = Tools.moreThanZeroResultJSON(num);
//        return result;
//    }
//
//
//    @Override
//    public String remove(String id, String userId) {
//        Customer customer = customerMapper.selectByPrimaryKey(id);
//        customer.setCancelFlag("9");
//        customer.setCancelId(userId);
//        customer.setCancelTime(new Date());
//        num = customerMapper.updateByPrimaryKey(customer);
//        result = Tools.moreThanZeroResultJSON(num);
//        return result;
//
//    }
    @Override
    public String changeAll(String json,
                            String newCustomername,
                            String newFKCustomername,
                            String newContractno,
                            String newOrdno,
                            String newReceiveaddress,
                            String newProductionplace,
                            String newPackno,
                            String userId,
                            String belongId) {
        List<Store> list = JSON.parseObject(json, new TypeReference<List<Store>>() {
        });
        Customer customer = new Customer();
        Customer kfcustomer = new Customer();
        if(newCustomername != null && !newCustomername.equals("")){
            customer = customerMapper.selectByName(newCustomername,belongId);

        }

        if(newFKCustomername != null && !newFKCustomername.equals("")){
            kfcustomer = customerMapper.selectByName(newFKCustomername,belongId);

        }

        for(int i = 0; i < list.size(); i++){
            InRecord inRecord = inRecordMapper.selectByPrimaryKey(list.get(i).getInId());
            if (newCustomername != null && !newCustomername.equals("")){
                list.get(i).setCustomer(customer);
                inRecord.setCustomerName(newCustomername);
            }
            if(newFKCustomername != null && !newFKCustomername.equals("")){
                list.get(i).setFkComponyId(kfcustomer.getId());
                num += storeMapper.updateFKByPKey(list.get(i));
                inRecord.setFkComponyName(kfcustomer.getId());
            }


            if (newContractno != null && !newContractno.equals("")){
                list.get(i).setContractNo(newContractno);
                inRecord.setContractNo(newContractno);
            } else if (newContractno.equals("0")) {
                list.get(i).setContractNo("");
                inRecord.setContractNo("");
            }

            if (newOrdno != null && !newOrdno.equals("")){
                list.get(i).setOrdNo(newOrdno);
                inRecord.setOrdNo(newOrdno);
            } else if (newOrdno.equals("0")) {
                list.get(i).setOrdNo("");
                inRecord.setOrdNo("");
            }

            if (newReceiveaddress != null && !newReceiveaddress.equals("")){
                list.get(i).setReceiveAddress(newReceiveaddress);
                inRecord.setReceiveAddress(newReceiveaddress);
            } else if (newReceiveaddress.equals("0")) {
                list.get(i).setReceiveAddress("");
                inRecord.setReceiveAddress("");
            }

            if (newProductionplace != null && !newProductionplace.equals("")){
                list.get(i).setProductionPlace(newProductionplace);
                inRecord.setProductionPlace(newProductionplace);
            } else if (newProductionplace.equals("0")) {
                list.get(i).setProductionPlace("");
                inRecord.setProductionPlace("");
            }

            if (newPackno != null && !newPackno.equals("")){
                list.get(i).setPackNo(newPackno);
                inRecord.setPackNo(newPackno);
            } else if (newPackno.equals("0")) {
                list.get(i).setPackNo("");
                inRecord.setPackNo("");
            }
            num += storeMapper.updateByPrimaryKey(list.get(i));


            num += inRecordMapper.updateIn(inRecord);

        }
        return Tools.moreThanZeroResultJSON(num);
    }
}
